#!/usr/bin/perl


# This script gets the list of core groups that are covered

use strict;
use warnings;
use IO::File;
use FileHandle;
use Getopt::Long;

my %options = (
	       coregroups         => undef,
	       gene_list          => undef,
	       output             => undef
	       );
&GetOptions(
	    'coregroups=s'        => \$options{coregroups},
	    'gene_list=s'         => \$options{gene_list},
	    'output=s'            => \$options{output}
	    );

#Usage
my $usage = "

USAGE: get_core_groups_coverage.pl -coregroups  <core groups> -gene_list <list of genes covered> -output <output file> 

";

die $usage unless ((-s $options{coregroups}) and (-s $options{gene_list}) and ($options{output}));

#Read list to make an array of genes covered
my $gene_list=new FileHandle("$options{gene_list}");
my %gene_hash;
while (<$gene_list>){
    chomp;
    my $line=$_;
    $gene_hash{$line}=1;
}

#Output file
my $o=new FileHandle("> $options{output}");

#Read ortholog data
my $cgf=new FileHandle("$options{coregroups}");
while(<$cgf>){
    chomp;
    my $line=$_;
    $line =~ s/\s+$//;
    my @array=split(/\s/,$line);
    my $flag=0;
    foreach my $a (@array){
	next if ($a eq "-");
	my $gi=(split(/\(/,$a))[0];
	if ($gene_hash{$gi}){
	    print $o "$line\n";
	    last;
	}
    }
}

$o->close;	
